/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   checker.c                                          :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: tmaze <tmaze@student.42.fr>                +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2019/02/23 13:35:15 by tmaze             #+#    #+#             */
/*   Updated: 2019/02/28 17:02:28 by tmaze            ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "push_swap.h"

int	check_input(char *in, int *ret)
{
	int		i;

	i = 0;
	if (in[i] && ft_issign(in[i]))
		i++;
	while (in[i] && ft_isdigit(in[i]))
		i++;
	if (in[i] == '\0' && ft_hasdigit(in) && ft_atois(in, ret))
		return (1);
	return (0);
}

int	get_params(t_psdata *data, int ac, char **av)
{
	t_stack	*new;
	char	**tab;
	int		nb;
	int		i;
	int		j;

	i = ac;
	nb = 0;
	while (--i > 0 && !(j = 0))
		if ((tab = ft_strsplitwhitespace(av[i])) != NULL)
		{
			while (tab[j])
				j++;
			while (--j >= 0)
				if (check_input(tab[j], &nb) && (new = ps_stknew(nb)) != NULL)
					ps_stkpsh(data, 'a', new);
				else
				{
					ft_putendl_fd("Error", 2);
					ps_stkclean(data);
					return (0);
				}
			ft_del_words_tables(&tab);
		}
	return (1);
}

int	is_op(char *buff)
{
	static char	ops[11][3] = {"sa", "sb", "ss", "pa", "pb", "ra",
								"rb", "rr", "rra", "rrb", "rrr"};
	size_t		i;

	i = 0;
	while (i < 11 && ft_strcmp(buff, ops[i]) != 0)
		i++;
	return (i < 11 && ft_strcmp(buff, ops[i]) == 0);
}

int	main(int ac, char **av)
{
	t_psdata	data;
	t_stack		*new;
	t_list		*nop;
	char		buff[5];
	int			ret;

	ps_initdata(&data);
	ft_memset(buff, '\0', 5);
	if (!get_params(&data, ac, av))
		return (0);
	new = data.a;
	if (new == NULL)
		ft_putendl("Empty");
	else
		while ((ret = read(1, buff, 4)) > 0)
		{
			buff[ft_strlen(buff) - 1] = '\0';
			if (ret > 4 || !is_op(buff) || (nop = ft_lstnew(buff, 4)) == NULL)
			{
				ft_putendl_fd("Error", 2);
				ps_stkclean(&data);
				return (1);
			}
			printf("%d\n", ret);
			ft_lstaddend(&(data.op), nop);
		}
	ps_stkclean(&data);
	return (0);
}
